#property indicator_separate_window
#property indicator_buffers    5
#property indicator_color1     Red
#property indicator_color2     Maroon
#property indicator_color3     LimeGreen
#property indicator_color4     DarkGreen
#property indicator_color5     Gray
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_width5     1
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern string TimeFrame         = "Current time frame";
extern int    period            = 13;
extern int    metod             = MODE_SMA;
extern int    price             = PRICE_CLOSE;

extern bool   alertsOn          = false;
extern bool   alertsOnZeroCross = false;
extern bool   alertsOnSlope     = false;
extern bool   alertsOnCurrent   = false;
extern bool   alertsMessage     = false;
extern bool   alertsSound       = false;
extern bool   alertsEmail       = false;
extern bool   alertsNotify      = false;

double Buf[];
double Upa[];
double Upb[];
double Dna[];
double Dnb[];
double trend[];
double slope[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
int    timeFrame;


int init()
  {
   IndicatorBuffers(7);
   SetIndexBuffer(0,Dna);   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Dnb);   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Upa);   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,Upb);   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,Buf);
   SetIndexBuffer(5,trend);
   SetIndexBuffer(6,slope);
   SetLevelValue(0,0);
   
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+"Force index volume MTF ("+period+","+metod+","+price+")");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
//---- initialization done
   return(0);
  }

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Buf[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);            
                     Dna[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,metod,price,0,y);
                     Dnb[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,metod,price,1,y);
                     Upa[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,metod,price,2,y);
                     Upb[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,metod,price,3,y);
                     Buf[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,metod,price,4,y);
                     trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,metod,price,5,y);
                     slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,metod,price,6,y);
               }
            manageAlerts();
            return(0);
            }
             
             //
             //
             //
             //
             //
             
             for(i=limit; i>=0; i--) Buf[i] = iVolume(NULL,0,i)*(iMA(NULL,0,period,0,metod,price,i) - iMA(NULL,0,period,0,metod,price,i+1));                 
             for(i=limit; i>=0; i--)
             {
                Dna[i]   = EMPTY_VALUE;
                Dnb[i]   = EMPTY_VALUE;
                Upa[i]   = EMPTY_VALUE;
                Upb[i]   = EMPTY_VALUE;
                slope[i] = slope[i+1];
                trend[i] = trend[i+1];
                if(Buf[i]>Buf[i+1]) slope[i] = 1;
                if(Buf[i]<Buf[i+1]) slope[i] =-1;
                if(Buf[i]>0)        trend[i] = 1;
                if(Buf[i]<0)        trend[i] =-1;
                if (trend[i] == 1 && slope[i] == 1) Upa[i] = Buf[i];
                if (trend[i] == 1 && slope[i] ==-1) Upb[i] = Buf[i];
                if (trend[i] ==-1 && slope[i] ==-1) Dna[i] = Buf[i];
                if (trend[i] ==-1 && slope[i] == 1) Dnb[i] = Buf[i];
             }
manageAlerts();
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnZeroCross && trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(time1,mess1,whichBar,"crossing zero up");
         if (trend[whichBar] == -1) doAlert(time1,mess1,whichBar,"crossing zero down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar] ==  1) doAlert(time2,mess2,whichBar,"sloping up");
         if (slope[whichBar] == -1) doAlert(time2,mess2,whichBar,"sloping down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Force Index volume ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Force index volume MTF"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

